/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * This code has been autogenerated, do not edit
 */

#include <stdlib.h>
#include <string.h>

#include "ArtNetConfMsgs.h"
#include "ArtNetConfParser.h"
#include "artnet_conf_messages.h"


/*
 * Really simple test, create a message, pack it and unpack it
 */
int test_port_req() {
  int l = sizeof(lla_artnet_conf_msg_port_req) + lla_artnet_conf_header_size;
  uint8_t buf[l];
  int r = 0;

  ArtNetConfMsgPortReq *m = new ArtNetConfMsgPortReq();
  ArtNetConfMsg *m2 ;
  ArtNetConfMsgPortReq *m3 ;
  ArtNetConfParser *p = new ArtNetConfParser() ;


  r = m->pack(buf,l);

  if ( r != l ) {
    printf("Failed to pack ArtNetConfMsgPortReq\n");
    return 1;
  }

  m2 = p->parse(buf,r);
	
  if (m2 == NULL) {
    printf("Failed to parse a ArtNetConfMsgPortReq message\n");
    return 1;
  }

  if( m->type() != m2->type() ) {
    printf("Invalid msg type %i != %i\n", m->type(),  m2->type() );
    return 1;
  }
	
  m3 = (ArtNetConfMsgPortReq*) m2;


  return 0;
}

/*
 * Really simple test, create a message, pack it and unpack it
 */
int test_prm_rep() {
  int l = sizeof(lla_artnet_conf_msg_prm_rep) + lla_artnet_conf_header_size;
  uint8_t buf[l];
  int r = 0;

  ArtNetConfMsgPrmRep *m = new ArtNetConfMsgPrmRep();
  ArtNetConfMsg *m2 ;
  ArtNetConfMsgPrmRep *m3 ;
  ArtNetConfParser *p = new ArtNetConfParser() ;


  r = m->pack(buf,l);

  if ( r != l ) {
    printf("Failed to pack ArtNetConfMsgPrmRep\n");
    return 1;
  }

  m2 = p->parse(buf,r);
	
  if (m2 == NULL) {
    printf("Failed to parse a ArtNetConfMsgPrmRep message\n");
    return 1;
  }

  if( m->type() != m2->type() ) {
    printf("Invalid msg type %i != %i\n", m->type(),  m2->type() );
    return 1;
  }
	
  m3 = (ArtNetConfMsgPrmRep*) m2;


  return 0;
}


int main(int argc, char *argv[]) {
  int r = 0;

  r += test_port_req();

  r += test_prm_rep();


  return r;
}
