/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * This code has been autogenerated, do not edit
 */

#include <stdlib.h>
#include <string.h>

#include "UsbProConfMsgs.h"
#include "UsbProConfParser.h"
#include "usbpro_conf_messages.h"


/*
 * Really simple test, create a message, pack it and unpack it
 */
int test_prm_req() {
  int l = sizeof(lla_usbpro_conf_msg_prm_req) + lla_usbpro_conf_header_size;
  uint8_t buf[l];
  int r = 0;

  UsbProConfMsgPrmReq *m = new UsbProConfMsgPrmReq();
  UsbProConfMsg *m2 ;
  UsbProConfMsgPrmReq *m3 ;
  UsbProConfParser *p = new UsbProConfParser() ;


  r = m->pack(buf,l);

  if ( r != l ) {
    printf("Failed to pack UsbProConfMsgPrmReq\n");
    return 1;
  }

  m2 = p->parse(buf,r);
	
  if (m2 == NULL) {
    printf("Failed to parse a UsbProConfMsgPrmReq message\n");
    return 1;
  }

  if( m->type() != m2->type() ) {
    printf("Invalid msg type %i != %i\n", m->type(),  m2->type() );
    return 1;
  }
	
  m3 = (UsbProConfMsgPrmReq*) m2;


  return 0;
}

/*
 * Really simple test, create a message, pack it and unpack it
 */
int test_prm_rep() {
  int l = sizeof(lla_usbpro_conf_msg_prm_rep) + lla_usbpro_conf_header_size;
  uint8_t buf[l];
  int r = 0;

  UsbProConfMsgPrmRep *m = new UsbProConfMsgPrmRep();
  UsbProConfMsg *m2 ;
  UsbProConfMsgPrmRep *m3 ;
  UsbProConfParser *p = new UsbProConfParser() ;

  m->set_firmware( rand() );
  m->set_brk( rand() );
  m->set_mab( rand() );
  m->set_rate( rand() );

  r = m->pack(buf,l);

  if ( r != l ) {
    printf("Failed to pack UsbProConfMsgPrmRep\n");
    return 1;
  }

  m2 = p->parse(buf,r);
	
  if (m2 == NULL) {
    printf("Failed to parse a UsbProConfMsgPrmRep message\n");
    return 1;
  }

  if( m->type() != m2->type() ) {
    printf("Invalid msg type %i != %i\n", m->type(),  m2->type() );
    return 1;
  }
	
  m3 = (UsbProConfMsgPrmRep*) m2;

  if( m3->get_firmware() != m->get_firmware() ) {
    printf("int16 check failed\n");
    return 1;
  }
  if( m3->get_brk() != m->get_brk() ) {
    printf("int8 check failed\n");
    return 1;
  }
  if( m3->get_mab() != m->get_mab() ) {
    printf("int8 check failed\n");
    return 1;
  }
  if( m3->get_rate() != m->get_rate() ) {
    printf("int8 check failed\n");
    return 1;
  }

  return 0;
}

/*
 * Really simple test, create a message, pack it and unpack it
 */
int test_sprm_req() {
  int l = sizeof(lla_usbpro_conf_msg_sprm_req) + lla_usbpro_conf_header_size;
  uint8_t buf[l];
  int r = 0;

  UsbProConfMsgSprmReq *m = new UsbProConfMsgSprmReq();
  UsbProConfMsg *m2 ;
  UsbProConfMsgSprmReq *m3 ;
  UsbProConfParser *p = new UsbProConfParser() ;

  m->set_brk( rand() );
  m->set_mab( rand() );
  m->set_rate( rand() );

  r = m->pack(buf,l);

  if ( r != l ) {
    printf("Failed to pack UsbProConfMsgSprmReq\n");
    return 1;
  }

  m2 = p->parse(buf,r);
	
  if (m2 == NULL) {
    printf("Failed to parse a UsbProConfMsgSprmReq message\n");
    return 1;
  }

  if( m->type() != m2->type() ) {
    printf("Invalid msg type %i != %i\n", m->type(),  m2->type() );
    return 1;
  }
	
  m3 = (UsbProConfMsgSprmReq*) m2;

  if( m3->get_brk() != m->get_brk() ) {
    printf("int8 check failed\n");
    return 1;
  }
  if( m3->get_mab() != m->get_mab() ) {
    printf("int8 check failed\n");
    return 1;
  }
  if( m3->get_rate() != m->get_rate() ) {
    printf("int8 check failed\n");
    return 1;
  }

  return 0;
}

/*
 * Really simple test, create a message, pack it and unpack it
 */
int test_sprm_rep() {
  int l = sizeof(lla_usbpro_conf_msg_sprm_rep) + lla_usbpro_conf_header_size;
  uint8_t buf[l];
  int r = 0;

  UsbProConfMsgSprmRep *m = new UsbProConfMsgSprmRep();
  UsbProConfMsg *m2 ;
  UsbProConfMsgSprmRep *m3 ;
  UsbProConfParser *p = new UsbProConfParser() ;

  m->set_status( rand() );

  r = m->pack(buf,l);

  if ( r != l ) {
    printf("Failed to pack UsbProConfMsgSprmRep\n");
    return 1;
  }

  m2 = p->parse(buf,r);
	
  if (m2 == NULL) {
    printf("Failed to parse a UsbProConfMsgSprmRep message\n");
    return 1;
  }

  if( m->type() != m2->type() ) {
    printf("Invalid msg type %i != %i\n", m->type(),  m2->type() );
    return 1;
  }
	
  m3 = (UsbProConfMsgSprmRep*) m2;

  if( m3->get_status() != m->get_status() ) {
    printf("int8 check failed\n");
    return 1;
  }

  return 0;
}

/*
 * Really simple test, create a message, pack it and unpack it
 */
int test_ser_req() {
  int l = sizeof(lla_usbpro_conf_msg_ser_req) + lla_usbpro_conf_header_size;
  uint8_t buf[l];
  int r = 0;

  UsbProConfMsgSerReq *m = new UsbProConfMsgSerReq();
  UsbProConfMsg *m2 ;
  UsbProConfMsgSerReq *m3 ;
  UsbProConfParser *p = new UsbProConfParser() ;


  r = m->pack(buf,l);

  if ( r != l ) {
    printf("Failed to pack UsbProConfMsgSerReq\n");
    return 1;
  }

  m2 = p->parse(buf,r);
	
  if (m2 == NULL) {
    printf("Failed to parse a UsbProConfMsgSerReq message\n");
    return 1;
  }

  if( m->type() != m2->type() ) {
    printf("Invalid msg type %i != %i\n", m->type(),  m2->type() );
    return 1;
  }
	
  m3 = (UsbProConfMsgSerReq*) m2;


  return 0;
}

/*
 * Really simple test, create a message, pack it and unpack it
 */
int test_ser_rep() {
  int l = sizeof(lla_usbpro_conf_msg_ser_rep) + lla_usbpro_conf_header_size;
  uint8_t buf[l];
  int r = 0;

  UsbProConfMsgSerRep *m = new UsbProConfMsgSerRep();
  UsbProConfMsg *m2 ;
  UsbProConfMsgSerRep *m3 ;
  UsbProConfParser *p = new UsbProConfParser() ;

  m->set_status( rand() );

  r = m->pack(buf,l);

  if ( r != l ) {
    printf("Failed to pack UsbProConfMsgSerRep\n");
    return 1;
  }

  m2 = p->parse(buf,r);
	
  if (m2 == NULL) {
    printf("Failed to parse a UsbProConfMsgSerRep message\n");
    return 1;
  }

  if( m->type() != m2->type() ) {
    printf("Invalid msg type %i != %i\n", m->type(),  m2->type() );
    return 1;
  }
	
  m3 = (UsbProConfMsgSerRep*) m2;

  if( m3->get_status() != m->get_status() ) {
    printf("int8 check failed\n");
    return 1;
  }

  return 0;
}


int main(int argc, char *argv[]) {
  int r = 0;

  r += test_prm_req();

  r += test_prm_rep();

  r += test_sprm_req();

  r += test_sprm_rep();

  r += test_ser_req();

  r += test_ser_rep();


  return r;
}
